# coding: utf-8

"""
    Pure1 Public REST API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re

# python 2 and python 3 compatibility library
import six

from ..api_client import ApiClient


class AuthorizationApi(object):

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def oauth210_token_post(self, grant_type, subject_token, subject_token_type, **kwargs):
        """Get access token

        Exchanges an ID token for an OAuth 2.0 access token. 
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.oauth210_token_post(grant_type, subject_token, subject_token_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str grant_type: The method with which an access token will be obtained. While the OAuth 2.0 spec allows for multiple grant types, currently only `urn:ietf:params:oauth:grant-type:token-exchange` is supported here, which indicates that a token exchange is being performed. (required)
        :param str subject_token: A security token that represents the identity of the party on behalf of whom the request is being made. Each token must be issued by a trusted identity provider, which must be either a registered application in Pure1 or an enabled API client on the array. Each token must be a JSON Web Token and must contain the following claims: > | JWT claim | Location | API client field | Description | Required By | > |-|-|-|-|-| > | kid | Header | key_id | Key ID of API client that issues the identity token. | FlashArray and FlashBlade only. | > | aud | Payload | id | ID of API client that issues the identity token. | FlashArray and FlashBlade only. | > | sub | Payload | | Username of user the token should be issued for. This must be a valid user in the system. | FlashArray and FlashBlade only. | > | iss | Payload | issuer | Application ID for Pure1, or API client's trusted identity issuer on the array. | All products. | > | iat | Payload | | Time at which your identity token was issued. | All products. | > | exp | Payload | | Time at which the identity token will expire. | All products. |  Each token must also be signed with the private key that is paired with the API client's public key. (required)
        :param str subject_token_type: An identifier that indicates the type of the security token in the `subject_token` parameter. While the OAuth 2.0 spec allows for multiple subject token types, currently only `urn:ietf:params:oauth:token-type:jwt` is supported here, which indicates that the token is a JSON Web Token. (required)
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.oauth210_token_post_with_http_info(grant_type, subject_token, subject_token_type, **kwargs)
        else:
            (data) = self.oauth210_token_post_with_http_info(grant_type, subject_token, subject_token_type, **kwargs)
            return data

    def oauth210_token_post_with_http_info(self, grant_type, subject_token, subject_token_type, **kwargs):
        """Get access token

        Exchanges an ID token for an OAuth 2.0 access token. 
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.oauth210_token_post_with_http_info(grant_type, subject_token, subject_token_type, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str grant_type: The method with which an access token will be obtained. While the OAuth 2.0 spec allows for multiple grant types, currently only `urn:ietf:params:oauth:grant-type:token-exchange` is supported here, which indicates that a token exchange is being performed. (required)
        :param str subject_token: A security token that represents the identity of the party on behalf of whom the request is being made. Each token must be issued by a trusted identity provider, which must be either a registered application in Pure1 or an enabled API client on the array. Each token must be a JSON Web Token and must contain the following claims: > | JWT claim | Location | API client field | Description | Required By | > |-|-|-|-|-| > | kid | Header | key_id | Key ID of API client that issues the identity token. | FlashArray and FlashBlade only. | > | aud | Payload | id | ID of API client that issues the identity token. | FlashArray and FlashBlade only. | > | sub | Payload | | Username of user the token should be issued for. This must be a valid user in the system. | FlashArray and FlashBlade only. | > | iss | Payload | issuer | Application ID for Pure1, or API client's trusted identity issuer on the array. | All products. | > | iat | Payload | | Time at which your identity token was issued. | All products. | > | exp | Payload | | Time at which the identity token will expire. | All products. |  Each token must also be signed with the private key that is paired with the API client's public key. (required)
        :param str subject_token_type: An identifier that indicates the type of the security token in the `subject_token` parameter. While the OAuth 2.0 spec allows for multiple subject token types, currently only `urn:ietf:params:oauth:token-type:jwt` is supported here, which indicates that the token is a JSON Web Token. (required)
        :return: InlineResponse200
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['grant_type', 'subject_token', 'subject_token_type']
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method oauth210_token_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'grant_type' is set
        if ('grant_type' not in params or
                params['grant_type'] is None):
            raise ValueError("Missing the required parameter `grant_type` when calling `oauth210_token_post`")
        # verify the required parameter 'subject_token' is set
        if ('subject_token' not in params or
                params['subject_token'] is None):
            raise ValueError("Missing the required parameter `subject_token` when calling `oauth210_token_post`")
        # verify the required parameter 'subject_token_type' is set
        if ('subject_token_type' not in params or
                params['subject_token_type'] is None):
            raise ValueError("Missing the required parameter `subject_token_type` when calling `oauth210_token_post`")

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'grant_type' in params:
            form_params.append(('grant_type', params['grant_type']))
        if 'subject_token' in params:
            form_params.append(('subject_token', params['subject_token']))
        if 'subject_token_type' in params:
            form_params.append(('subject_token_type', params['subject_token_type']))

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(
            ['application/x-www-form-urlencoded'])

        # Authentication setting
        auth_settings = []

        return self.api_client.call_api(
            '/oauth2/1.0/token', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse200',
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
